unit Crypt32;
{
*************************************************************************
* Name:         Crypt32.Pas                                             *
* Description:  32 bits encode/decode module                            *
*               2^96 variants it is very high to try hack               *
* Purpose:      Good for encrypting passwors and text                   *
* Security:     avoid use StartKey less than 256                        *
*               if it use only for internal use you may use default     *
*               key, but MODIFY unit before compiling                   *
* Call:         Encrypted := Encrypt(InString,StartKey,MultKey,AddKey)  *
*               Decrypted := Decrypt(InString,StartKey)                 *
* Parameters:   InString  = AnsiString that need to encrypt, decrypt    *
*               MultKey   = MultKey key                                 *
*               AddKey      Second key                                  *
*               StartKey  = Third key                                   *
*               (posible use defaults from interface)                   *
* Return:       OutString = result string                               *
* Editor:       Best viewed with Tab stops = 2, Courier new             *
* Started:      01.08.1996                                              *
* Revision:     22.05.1997 - ver.2.01 converted from Delphi 1           *
*               and made all keys as parameters, before only start key  *
*               11.05.2002 - ver 2.02 small error                       *
* Platform:     Tested on Delphi 2, 3, 5                                *
*               work in Delphi 1.0, 2^48 variants, 0..255 strings       *
* Author:       Anatoly Podgoretsky                                     *
*               Base alghoritm from Borland                             *
* Address:      Vahe 4-31, Johvi, Estonia, EE2045, tel. +372 (33) 56176 *
* e-mail:       anatoly@podgoretsky.com                                 *
* Status:       Freeware                                                *
*************************************************************************
* Modified:     Supports Delphi 1.0 & 2.0                               *
*               Overflow checking removed                               *
* By:           Martin Djerns                                          *
* e-mail:       djernaes@einstein.ot.dk                                 *
* web:          einstein.ot.dk/~djernaes                                *
*************************************************************************
}
interface

const
  StartKey = 981;        { Start default key }
  MultKey  = 12674;      { Mult default key }
  AddKey   = 35891;      { addd default key }

function Encrypt(const InString:string; StartKey,MultKey,AddKey:Integer): string;
function Decrypt(const InString:string; StartKey,MultKey,AddKey:Integer): string;

implementation

{$R-}
{$Q-}
{*******************************************************
 * Standard Encryption algorithm - Copied from Borland *
 *******************************************************}
function Encrypt(const InString:string; StartKey,MultKey,AddKey:Integer): string;
var
  I : Integer;
begin
  Result := '';
  for I := 1 to Length(InString) do
  begin
    Result := Result + CHAR(Byte(InString[I]) xor (StartKey shr 8));
    StartKey := (Byte(Result[I]) + StartKey) * MultKey + AddKey;
  end;
end;
{*******************************************************
 * Standard Decryption algorithm - Copied from Borland *
 *******************************************************}
function Decrypt(const InString:string; StartKey,MultKey,AddKey:Integer): string;
var
  I : Integer;
begin
  Result := '';
  for I := 1 to Length(InString) do
  begin
    Result := Result + CHAR(Byte(InString[I]) xor (StartKey shr 8));
    StartKey := (Byte(InString[I]) + StartKey) * MultKey + AddKey;
  end;
end;
{$R+}
{$Q+}

end.
